<script setup lang="ts">
import { defineProps, onMounted, ref } from 'vue'
import { useStore } from 'vuex'
import type { Project } from '@/api/gitlabHelperApi/projectsApi'
import { ratioColor, statusColor, timeAgo } from '@/components/gitlab/helpers'

const props = defineProps<{
  projects: Project[]
}>()

const store = useStore()
const user = ref({ username: '', rol: '' })

onMounted(() => {
  user.value = store.getters.user
  console.debug('ProjectsCardComponent.projects: ', props.projects)
})
</script>

<template>
  <VRow class="card-container">
    <VCol
      v-for="project in props.projects"
      :key="project.id"
      cols="12"
      sm="6"
      md="4"
      lg="3"
      class="d-flex-column"
    >
      <VCard class="flex-card">
        <VCardItem style="padding: 18px;">
          <VRow
            class="align-items-center"
            no-gutters
          >
            <VCol cols="auto mr-2">
              <VIcon
                color="primary"
                icon="tabler-files"
                size="24"
              />
            </VCol>
            <VCol
              class="flex-grow-1"
              style="overflow: hidden; white-space: nowrap; text-overflow: ellipsis;"
            >
              <VCardTitle
                class="d-flex align-items-center"
                style="font-size: 1rem; font-weight: bold;"
              >
                <p class="mb-0">
                  {{ project.name }}
                </p>
              </VCardTitle>
            </VCol>
            <VCol cols="auto">
              <VBtn
                :href="project.web_url"
                variant="text"
                size="small"
              >
                <VIcon
                  color="primary"
                  icon="tabler-external-link"
                  size="20"
                />
              </VBtn>
            </VCol>
          </VRow>
        </VCardItem>

        <!--
          VCardText class="flex-text pb-1">
          Description: {{ project.description }}
          </VCardText
        -->

        <VCardText class="d-flex align-center flex-wrap pb-1">
          <div class="d-flex justify-space-between flex-wrap full-width">
            <VProgressCircular
              :model-value="project.health.ratio * 10"
              :size="35"
              :color="ratioColor(project.health.ratio)"
              class="me-10"
            >
              <span class="text-body-1 text-high-emphasis font-weight-medium">
                {{ project.health.ratio }}
              </span>
            </VProgressCircular>
          </div>
        </VCardText>

        <VCardText class="d-flex align-center flex-wrap pb-1">
          <span class="me-4">Last execution status:</span>
          <VChip
            label
            :color="statusColor(project.health.status)"
          >
            {{ project.health.status }}
          </VChip>
        </VCardText>

        <VCardText class="d-flex align-center flex-wrap pb-1">
          <span class="me-4">Last success:</span>
          <span>{{ timeAgo(project.health.last_success) }}</span>
        </VCardText>

        <VCardText class="d-flex align-center flex-wrap pb-1">
          <span class="me-4">Last failure:</span>
          <span>{{ timeAgo(project.health.last_failure) }}</span>
        </VCardText>

        <VCardActions>
          <VBtn :to="{ name: 'workspace', params: { id: project.namespace.id, projectId: project.id } }">
            Workspace
          </VBtn>
        </VCardActions>
      </VCard>
    </VCol>
  </VRow>
</template>

<style scoped>
.card-container {
  display: flex;
  align-items: stretch;
}

.d-flex-column {
  display: flex;
  flex-direction: column;
}

.flex-card {
  flex-grow: 1;
}

.full-width {
  width: 100%;
}
</style>
